#include "obj.hpp"

//constructor
obj::obj()
{
    _position = point();
    _radius = 0;
}

obj::obj(const point& pos, float radius)
{
    _position = pos;
    _radius = radius;
}

//getter
const point& obj::position()const
{
    return _position;
}

float obj::radius()const
{
    return _radius;
}

float obj::radiusSQ()const
{
    return _radius*_radius;
}

//collision detection
bool obj::collide(const point& pos)const
{
    return (pos-_position).magSQ() < _radius*_radius;
}

bool obj::collide(const obj& other)const
{
    return (other._position-_position).magSQ() < radiusSQ()+other.radiusSQ();
}

//print out
ostream& operator << (ostream& out, obj& o)
{
    out << "obj at " << o._position 
        << " with collision radius of " << o._radius;
    return out;
}

istream& operator >> (istream& in, obj& p)
{
    float x,
          y,
          z,
          r;
    char c;
    
    in >> c >> x
       >> c >> y
       >> c >> z
       >> c >> r;
    
    p._position.setX(x);
    p._position.setY(y);
    p._position.setZ(z);
    
    p._radius = r;
    
    return in;
}
